<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.domain;

import lombok.Data;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.sql.Timestamp;

/**
 * 实体[${item.codeName}] 数据对象
 */
@Entity
@Table(name = "${item.getTableName()?lower_case}"
<#if item.getAllPSDEDBIndexs() ??>
        <#assign si = ''/>
        <#list item.getAllPSDEDBIndexs() as index>
        <#if index.getAllPSDEDBIndexFields()??>
            <#assign strindex = ''/>
            <#list index.getAllPSDEDBIndexFields() as fs>
                <#assign strindex = strindex + fs.getName() + ','/>
            </#list>
            <#assign inType = ''/>
            <#if index.getIndexType()=='NORMAL'><#assign inType = 'false'/><#else><#assign inType = 'true'/></#if>
                    <#assign si = si + '@Index(name = "${index.getName()}",  columnList="${strindex?substring(0,strindex?length-1)}", unique = ${inType}),'/>
        </#if>
        </#list>
        ,indexes = {${si?substring(0,si?length-1)}}
</#if>
        )
@Data
public class ${item.codeName}{

<#comment>输出当前实体属性</#comment>
<#list item.getPSDEFields() as defield>
<#if defield.isKeyDEField()>
    @Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid")
<#else>
    <#if defield.getDataType()!="PICKUP">
    @Column(name = "${defield.codeName?lower_case}"
            ,nullable = <#if defield.isAllowEmpty()>true<#else>false</#if>
            <#if defield.getDefaultValue()?? || defield.getLogicName()??>
            ,columnDefinition="${srfdatatype(defield.getStdDataType())} <#switch srfdatatype(defield.getStdDataType())><#case "VARCHAR"><#if defield.getLength()??>(${defield.getLength()})<#else>(255)</#if><#break><#case "INT"><#if defield.getLength()??>(${defield.getLength()})<#else>(10)</#if><#break><#case "FLOAT"><#if defield.getLength()?? && defield.getPrecision()??>(${defield.getLength()},${defield.getPrecision()})<#else>(10,2)</#if><#break><#default> </#switch> <#if defield.getDefaultValue()?? && defield.getDefaultValue()!=''>DEFAULT '${defield.getDefaultValue()}'<#else>DEFAULT null</#if> <#if defield.getLogicName()??>Comment '${defield.getLogicName()}'</#if>"
            </#if>
    )
    </#if>
</#if>
    <#if defield.getDataType()!="PICKUP">
    private ${srfjavatype(defield.stdDataType)} ${defield.codeName?lower_case};
    </#if>
</#list>

<#comment>输出当前关系从实体</#comment>
<#if item.getMinorPSDERs?? && item.getMinorPSDERs()??>
    <#list item.getMinorPSDERs() as MinorPSDER>
        <#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
        <#assign wjz = MinorPSDER.getPSPickupDEField()>
    <#if MinorPSDER.getDERType()=='DER11'>
    @OneToOne(fetch = FetchType.LAZY)
    @JoinColumn(name="${wjz.getName()?lower_case}",foreignKey = @ForeignKey(name = "${MinorPSDER.getName()}"))
    private ${MajorEntity.getCodeName()} ${wjz.getName()?lower_case};
    </#if>
    <#if MinorPSDER.getDERType()=='DER1N'>
    @ManyToOne
    @JoinColumn(name="${wjz.getName()?lower_case}",foreignKey = @ForeignKey(name = "${MinorPSDER.getName()}"))
    private ${MajorEntity.getCodeName()} ${wjz.getName()?lower_case};
    </#if>
    </#list>
</#if>

<#comment>输出当前关系主实体</#comment>
<#if item.getMajorPSDERs?? && item.getMajorPSDERs()??>
    <#list item.getMajorPSDERs() as MajorPSDER>
        <#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>
        <#assign Entity_cap_first = MajorPSDER.getPSPickupDEField().getName()?lower_case>
    <#if MajorPSDER.getDERType()=='DER11'>
    @OneToOne(
            mappedBy = "${Entity_cap_first}",
            cascade = CascadeType.ALL,
            orphanRemoval = true,
            fetch = FetchType.LAZY
    )
    private ${MinorEntity.getCodeName()} ${MinorEntity.getCodeName()?lower_case}s;

    public void add${MinorEntity.getCodeName()}(${MinorEntity.getCodeName()} ${MinorEntity.getCodeName()?lower_case}) {
        ${MinorEntity.getCodeName()?lower_case}.set${Entity_cap_first?cap_first}( this );
        this.${MinorEntity.getCodeName()?lower_case}s = ${MinorEntity.getCodeName()?lower_case};
    }

    public void remove${MinorEntity.getCodeName()}() {
        if ( ${MinorEntity.getCodeName()?lower_case}s != null ) {
            ${MinorEntity.getCodeName()?lower_case}s.set${Entity_cap_first?cap_first}( null );
            this.${MinorEntity.getCodeName()?lower_case}s = null;
        }
    }
    </#if>
    <#if MajorPSDER.getDERType()=='DER1N'>
    @OneToMany(mappedBy = "${Entity_cap_first}", cascade = CascadeType.ALL, orphanRemoval = true)
    private List <${MinorEntity.getCodeName()}> ${MinorEntity.getCodeName()?lower_case}s = new ArrayList<>();

    public void add${MinorEntity.getCodeName()}(${MinorEntity.getCodeName()} ${MinorEntity.getCodeName()?lower_case}) {
        ${MinorEntity.getCodeName()?lower_case}s.add( ${MinorEntity.getCodeName()?lower_case} );
        ${MinorEntity.getCodeName()?lower_case}.set${Entity_cap_first?cap_first}( this );
    }

    public void remove${MinorEntity.getCodeName()}(${MinorEntity.getCodeName()} ${MinorEntity.getCodeName()?lower_case}) {
        ${MinorEntity.getCodeName()?lower_case}s.remove( ${MinorEntity.getCodeName()?lower_case} );
        ${MinorEntity.getCodeName()?lower_case}.set${Entity_cap_first?cap_first}( null );
    }
    </#if>
    </#list>
</#if>
<#assign str = ""/>
<#list item.getPSDEFields() as defield>
    <#if defield.getDataType()!="PICKUP">
        <#assign str = str +'"${defield.codeName?lower_case}=" +${defield.codeName?lower_case}+","+'/>
    </#if>
</#list>
    @Override
    public String toString() {

        return ${str?substring(0,str?length-5)} ;
    }

}
